Short:    Fast ImageFX loaders(incl.PhotoCD)&savers
Author:   hhoff@pool.informatik.rwth-aachen.de (Helmut Hoffmann)
Uploader: hhoff@pool.informatik.rwth-aachen.de (Helmut Hoffmann)
Type:     gfx/misc

HHsFastImageFXModules 4.4 The probably fastest shareware ImageFX loader/saver modules
=========================

*** new: now with PhotoCD loading support ***

+++ new: now you can order HHsFastImageFXModules for a small add-on price
         with my new universal viewer "CyberShow" for all Amigas with OS3.0
         or higher and esp. for Cybergraphics systems +++

+++ new: now with support for RLE-compressed BMP images (8Bit or 1Bit) +++

The fast universal loader/saver modules can be used with ImageFX and
ImageFX-EGS. They are shareware; without a keyfile which you
get after registration, they will load and save all pictures in greyscale,
regardless if they are color or not, but the speed and format support is
the same, so that you can try if they fit your needs. The saver module
is only restricted for some formats (will be saved as greyscale); the
HHsXRL formats can always be saved in full color, so that you can try
out the interesting compression facilities of them (but please note that
the demo will load them only in greyscales).

The loader module currently supports the following file formats:

* IFF-ILBM (all standard formats 1 to 8Bit, EHB, HAM6, HAM8, 24Bit)
* PhotoCD (Base format 768x512 or 512x768 (portrait); linear 24Bit colors)
* PPM/PGM/PBM (P1&P4 b&w, P5 grey, P6 color)
* QRT (also known as dump format by PD raytracers as POV-Ray)
* Targa (RLE compr.&uncompr. 24Bit,32Bit,1Bit,8Bit grey/Colormap;incl. interleaved)
* PCX (compr.&uncompr. EGA1-4Bit, VGA 8Bit grey/Colormap and 24Bit)
* MacPaint (b&w compressed 1Bit format; datafork only)
* BMP (uncompr. 24Bit RGB,1Bit,4Bit or 8Bit Colormap; RLE compressed 8Bit,1Bit)
* TIF (packbit-compr./uncompr. Motorola formats 24Bit RGB, 1-8Bit grey/Colormap)
* EGS7.x window iconification file format
* DEEP (compr.&uncompr. 24Bit and 32Bit)
* RGB formats (RGB8, RGBN, RGB5)
* ACBM formats (1 to 8Bit, incl. HAM6/HAM8)
* FBM formats (8Bit grey/color and 24Bit)
* IFF-PBM (DPII) format
* Sun raster (1Bit, 8Bit grey/color and 24Bit uncompressed)
* YUV (color 1:1:1, 2:1:1, 4:1:1 and greyscale)
* VLAB raw (color 1:1:1, 2:1:1, 4:1:1 and greyscale)
* HHsYUVSq sequence format (sequential or random access)
* HHsXRL formats (1-8Bit ColorMap incl. HAM6/8, 8Bit grey, 24Bit RGB compressed)

* Picture DataTypes (many formats are available as DataTypes for OS3.x users)
* Animation DataTypes (many animation formats are available as DataTypes for
  OS3.1 users; currently only the first frame can be loaded with Animation DataTypes)

The saver module currently supports the following file formats:

* QRT (also known as dump format by PD raytracers as POV-Ray)
* Targa (RLE compr.&uncompr. 24Bit, 8Bit grey, 8Bit color map, 1Bit color map)
* HHsXRL formats (1-8Bit ColorMap incl. HAM6/8, 8Bit grey, 24Bit RGB compressed)
  with optional lossy reduction for TrueColor or greyscale pictures; this new
  file format series has surprisingly good (lossless) compression of raytraced
  24Bit pictures or undithered color mapped pictures with 2 to 256 colors;
  also very usable with ClipArt...

To install this, just copy the file named "-HHsFastImageFXLoader-" to your
ImageFX modules/loaders directory and "-HHsFastImageFXSaver-" to your
ImageFX modules/savers directory. They should work with standard ImageFX
(1.5x, 1.6x, 2.x, ...) as well as with ImageFX-EGS. I have tried them with
both ImageFX-EGS 1.6 and the new ImageFX 2.1 (thanks to NOVA design).
The speed advantages below have been measured with the new ImageFX 2.1.
Compared with ImageFX-EGS 1.6 some of them were even slightly higher
(in addition ImageFX-EGS comes with fewer standard loader modules).

The file format is automatically detected for loading except for the DataType
formats. If you want to load a picture with a DataType, you have to use the
"Load As" function from ImageFX and select "-HHsFastImageFXLoader-" manually
as loader module. The name of the loader module begins with a "-" so that it
appears first in the list of loader modules and thus is used before all
other loader modules. The typical speed advantage factors on my configuration
(see below) are:

DataTypes: depending on DataType, but usually loading will be significantly
           faster with my DataType support (compared to IFX 2.1 DataType support),
           e.g. about 1.5 for ZGIF DataType or REKO DataType...
IFF-ILBM: upto 4.75 (e.g. IFF 8Bit)
PPM/PBM: upto 7.2 (P6)
QRT: upto 4.4
Targa: upto 8.7 (uncompr.)
PCX: upto 11.2 (planar 4Bit)
BMP: upto 4.6 (24Bit)
TIF: upto 8.5 (packbit compr. 4Bit)
RGB: upto 3.7 (RGB8)
YUV: upto 5.6 (YUV1/4)
IFF-PBM: upto 1.3
SunRaster: upto 4.6 (grey)
MacPaint: upto 1.5
GIF: upto 2.1 (HHsFastIFXModules DataType loading with ZGIF-DataType compared with
               IFX-GIF loader)
PhotoCD: upto 2.0 (compared with PD-PCD loader in base size; in addition my loader
	 usually rotates portrait pictures automatically to correct orientation)

(only loading times compared, not displaying; my configuration: Amiga 3000;
 68030/25MHz; loading from Quantum harddrive; PhotoCD loading from NEC2x)

The loader includes many formats, which the original loaders (I compared with
ImageFX-EGS 1.61) do not support: PhotoCD, IFF-DEEP, IFF-ACBM, FBM, Sun raster,
VLab raw, DataTypes, RGB5, PBM4, TGA1, YUV grey, PCX grey, BMP compressed, EGS icons,
MacPaint (Datafork). Many of them are not supported by ImageFX 2.1 as well.

It also loads many formats, which are loaded with wrong colors (or other bugs)
in the original loaders, e.g IFF-ILBM-EHB, BMP1, PBM1, TIF1 grey, TGA grey.
The original PCX loader also had massive problems with loading VGA
pictures from CD-ROMs under the OS3.1 CD-file system. Although this is a bug in
the file system, I could work around this so that my loader should work with
CD-ROMs under the OS3.1 filesystem. Please note that some third party CD-ROM-
file systems can cause massive problems as well, so I recommend to use the
original Commodore OS3.1 filesystem.

The saver module can be used as normal (QRT only for true color/greyscale
buffers; Targa and HHsXRL also usable for rendered images from 2 to 256 colors).
The individual formats and variants are listed at the beginning of the list
of savers in the SaveAs window. The typical speed advantage for the fast
saver module:

QRT: upto 3.5
Targa: upto 3.8 (compressed)

Beside the speed advantage, the general compression is also better
(compared to ImageFX-EGS 1.61). Targa compression is sometimes 25% better
with my saver than with the original. The Targa saver also supports
the true greyscale format for greyscale pictures and allows compression
of rendered images as well. Rendered 1Bit images will be saved in 1Bit
Targa format. For good compression of e.g. raytracing pictures I recommend
my own file formats "HHsXRL", usable from 1Bit to 24Bit. This format is
also supported by my universal image viewer "CyberShow".

The fast loading/saving functions have all been written by me in assembler and
optimized for fastest speed. I did this for my famous shareware programs
*** CyberShow *** (universal viewer for all Amigas and esp. for Cybergraphics
users), *** EGSPhotoAlbum Professional *** (picture management and presentation
software for EGS) and *** EGS-TV Professional *** (sequence/animation editing,
framegrabber (VLab/IV24) and Blue Screen Keying software for EGS).
When new formats are implemented for my other programs (or the speed is improved
further), I will usually also update the modules, which registered user can then
use due to the keyfile concept.

Registration
============

You can register for the modules at the small add-on price of only 8US$ or
10DM if you order one of my other shareware programs, e.g. CyberShow, the
universal viewer for all Amigas with at least OS3.0 (loading the same formats
as the FastIFXModules and additional JPeg) or EGSPhotoAlbum or EGS-TV.
Just include the extra amount with your order for one of thoose programs
and specify your IFXModule order on the registration form. Demo versions
of the programs should be available at the same places where you got this demo.

Otherwise you should use the supplied registration form to register.

If you only want to register for the modules, the registration fee is
18US$ outside europe or 20DM in europe. You will also get the latest demo
versions of my other programs.

If you are already a registered user of one of my programs and now want to
register for the modules, the registration fee is 12US$ outside europe or
15DM (in europe). This includes the latest versions of my programs as update.

Send your filled in registration form together with cheque, international
postal money order or banknotes to:

                        Helmut Hoffmann
			Rubensstrasse 4
			D-41063 Mnchengladbach

			Germany

You can currently also contact me by EMail (e.g. for suggestions):

		hhoff@pool.informatik.rwth-aachen.de

No registrations by EMail! If you want to register, please write by ordinary mail
to my address above.

Special Thanks
==============

My special thanks go to Mr. Kermit Woodall and NOVA design for their kind support
and to all registered HHsFastIFXModule users, esp. thoose who made suggestions...

Disclaimer
----------

I tried my best to make the modules error-free. They have been checked
with enforcer and mungwall and work without problems on my configuration.
Nevertheless, as there are so many possible configurations, I can not
guarantee that this software will work on your configuration.

This software (program and documentation) is provided "as is" and
comes with no warranty, either expressed or implied.
The author is in no way responsible for any damage or loss that may
occur due to direct or indirect usage of this software. You use
this software entirely at your own risk.

Copyright and Distribution
--------------------------

HHsFastImageFXModule (modules and documentation) is copyright by

                        Helmut Hoffmann
			Rubensstrasse 4
			D-41063 Mnchengladbach

			Germany

The demo version may be freely distributed and used as
long as the following conditions are met:

1) All files have to be kept together

2) No file may be modified or crunched/packed.

   The only official way to distribute the demo packed is the
   original fastifxmodules.lha archive.
   The modules may not be disassembled or analysed. The limitations
   integrated in the demo version may under no circumstance be removed
   or bypassed.

3) Distributors may only charge for the duplication process (including media)
   and not for the software. Theese charges may not exceed the following
   limits: a) Demo on a PD-disk: 7$ (US-dollar) including
              postage&packing (in Germany: 10DM)
	   b) Demo on a PD-CD-ROM: 40$ (US-dollar) including
              postage&packing (in Germany: 60DM)
	   c) Demo on a BBS/Mailbox/ftp-site or other electronically
              callable system: Maximum charge 3$ (US-dollar) (in Germany: 5DM)
              for downloading
   Anyway, it must be made explictly clear to the buyer, that he does not
   pay for the modules (demo) itself but only for the duplication service.

4) It is not allowed to distribute this demo with any commercial product
   without a written permission by me. One exception is the distribution of
   the demo version with products not exceeding the above price limits (e.g.
   a cover-disk magazine for 7$ or less).

   The following companies have my explicit permission to distribute the
   demo with their products: NOVA Design, Ingenieurbro Helfrich.

5) The registered version may not be redistributed. It may only run on one
   machine per registration. It is allowed to make a backup copy of the
   original disk.

Version history
---------------

V1.0 (17th feb. 95): Support for IFF-ILBM,PPM,QRT,Targa,PCX,BMP,TIF,EGS7.x,
			DEEP,RGB,YUV,VLab,HHsYUVSq,DataTypes (picture&animation)

V2.0 (25th feb. 95): Added support for FBM (24Bit,8Bit),IFF-ACBM,IFF-PBM(DPII),
			Sun raster (1Bit, 8Bit, 24Bit uncompressed),PBM-P1,
			BMP 4Bit and interleaved Targa formats
		     Slight acceleration of some loading functions (esp. ILBM)
		     Improved DataType handling

V2.5 (1st march 95): Added support for MacPaint (1Bit compressed; datafork only),
			PBM-P4, PCX uncompressed and EGA-grey, Targa 1Bit,
			TIF packbit compressed and grey 1-4Bit
		     Many enhancements on various formats for more compatibility

V3.0 (14th march 95): Introduction of the fast saver module to supplement the
			fast loader module (QRT, Targa 1Bit/8Bit/24Bit, HHsXRL)
		      Added loader support for HHsXRL (1Bit-8Bit, HAM, 24Bit)
		      Acceleration of some planar loaders (e.g. ILBM, DataTypes)
		      Improved HAM6 loading quality
		      Correction of Targa 1Bit loading for compressed pictures

V3.1 (07th april 95): Acceleration of RGB8 and RGB5 loader function

V4.0 (30th april 95): Added support for PhotoCD (Base size; incl. portrait orientation)

V4.1 (09th may 95): Removed inconsistency in DataType-HAM8 handling for more compatibility
		    Filtering out of PCD overview files

V4.2 (07th july 95): Correction of Sun raster 24Bit loading (wrong colors and
			problems with odd sized images)
		     Updated documentation to reflect speed advantage compared
			to ImageFX 2.1 instead of ImageFX-EGS 1.6

V4.3 (12th july 95): Changed IFF-ILBM loading to not automatically load brushes
			containing a mask (you can still load them as pictures
			with my module by using the LoadAs function).
			This was neccessary as otherwise brushes could not be
			loaded together with their mask if the FastIFXModules
			were installed (as there is no Brush-LoadAs function).

V4.4 (21st july 95): Support for RLE compressed 8Bit and 1Bit BMP files
		     Bug fix for loading function which could lead to crashes if
		      certain non-picture files where detected as a picture

------------------------------------------------------------
                 Amiga Distribution System
------------------------------------------------------------
 
                        ADS Zone: 1
                  ADS Hatch Site: Don Plesky
              ADS Position: ADS Zone 1 Coordinator
                 BBS Name: EastPointe Amiga BBS
                 Phone Number(s): 810-773-6959
                 Network Address: 1:120/229  
                     Network Region: 11    
                   BBS Hours: 24 Hrs/Day
           BBS Mailer/Software: DLG Trapdoor/PDQmail
                   BBS Storage Space: 2 Gig 
               File Requestable :  <X> Y     < > N
               File Request Hours : All The Time



---------------------------------------------------------------
Help the Amiga! Join the ADS team Become a ADS Hub<=>Freq ADSINFO 
---------------------------------------------------------------

